import React from "react";
import LoginPage from './views/LoginPage.js';
import HomePage from './views/HomePage.js';
import './App.css';
import Helper from './helper.js'

class App extends React.Component {
  constructor() {
    super();
    this.state = {
      isLoggedIn: false,
    }
    this.commonObj = {
      setLoginState: this.setLoginState.bind(this)
    }
  }

  componentDidMount() {
    let token = Helper.getCookie('token');
    if(token.length) this.setLoginState(true);
  }

  async setLoginState(state) {
    if(state === true) {
      let res = await Helper.fetchAPI('user/check', 'GET');
      if(!res.ok) state = false;
    }
    if(state === this.state.isLoggedIn) return;

    this.setState({
      isLoggedIn: state
    });
  }

  render() {
    return this.state.isLoggedIn ? <HomePage commonObj={this.commonObj}></HomePage> : <LoginPage commonObj={this.commonObj}></LoginPage>
  }
}

export default App;
