const Helper = {  
    apiUrl: "http://localhost:5000/api/",
    filesUrl: "http://localhost:5000/file/",
    
    fetchAPI: (url, method, json = null, customBody = null) => {
        return new Promise((resolve, reject) => {
            let auth = Helper.getCookie("token") || "";
            let body = json ? JSON.stringify(json) : null;
            if (customBody) body = customBody;

            fetch(Helper.apiUrl + url, {
                method,
                cache: "no-cache",
                headers: {
                    "Authorization": "Bearer " + auth,
                },
                body
            })
            .then(async res => {
                json = await res.json();
                resolve({ok: res.ok, json});
            })
            .catch(err => {
                resolve({
                    ok: false, 
                    json: { message: "connection error"}
                });
            });
        });
    },
    setCookie: (cName, cValue, expDays) => {
        const d = new Date();
        d.setTime(d.getTime() + (expDays*24*60*60*1000));
        let expires = "expires="+ d.toUTCString();
        document.cookie = cName + "=" + cValue + ";" + expires + ";path=/";
    },
    getCookie: (cName) => {
        let name = cName + "=";
        let decodedCookie = decodeURIComponent(document.cookie);
        let ca = decodedCookie.split(';');
        for(let i = 0; i <ca.length; i++) {
            let c = ca[i];
            while (c.charAt(0) === ' ') {
            c = c.substring(1);
            }
            if (c.indexOf(name) === 0) {
            return c.substring(name.length, c.length);
            }
        }
        return "";
    },
    openImage: () => {
        return new Promise((resolve, reject) => {
            const input = document.createElement('input');
            input.type = 'file';
            input.accept = 'image/*';
            input.onchange = async e => {
                const file = e.target.files[0];
                resolve(file);
            }
            input.click();
        });
    }
}


export default Helper;