import React from "react";
import Helper from "../helper";

class HeaderView extends React.Component {
    constructor() {
        super();
        this.state = {
            bannerColor: 'yellow',
            bannerFontSize: '64px',
        }
    }

    componentDidMount() {
        window.addEventListener('scroll', this.handleScroll.bind(this));
    }
    
    componentWillUnmount() {
        window.removeEventListener('scroll', this.handleScroll.bind(this));
    }   
    
    handleScroll(e) {
        let scroll = e.srcElement.scrollingElement.scrollTop;
        let gradient = Math.min(scroll, 255);
        let size = Math.max(64 - scroll/5, 36);

        this.setState({
            bannerColor: `rgb(255, 255, ${gradient})`,
            bannerFontSize: `${size}px`
        });  
    }

    render() {
        let bannerStyle = {
            color: this.state.bannerColor,
            fontSize: this.state.bannerFontSize,
        }

        return (
            <>
                <div className="header">
                    <button onClick={this.onLogoutClick.bind(this)} className="logoutButton"></button>
                    <span className="banner" style={bannerStyle}>NibyInsta</span>
                    <div className="headerSym"></div>
                </div>
                <div className="headerSpace"></div>
            </>
        );
    }

    async onLogoutClick() {
        await Helper.fetchAPI('user/logout', 'GET');
        Helper.setCookie('token', '', -1);
        this.props.commonObj.setLoginState(false);
    }
}

export default HeaderView;