import React from "react";
import Popup from "./Popup";
import ProfilePage from "./ProfilePage";
import ChangePassPage from "./ChangePassPage";
import HeaderView from "./HeaderView";
import PhotoPage from "./PhotoPage";

class HomePage extends React.Component {
    constructor() {
        super();
        this.state = {
            popups: [],
            page: 'profile'
        }
    }

    setPage(name) {
        this.setState({
            page: name
        });
    }

    showPopup(text) {
        this.setState({
            popups: [...this.state.popups, text]
        });
    }

    closePopup() {
        let popupsNew = this.state.popups;
        popupsNew.pop();

        this.setState({
            popups: popupsNew
        })
    }

    getPage() {
        switch (this.state.page) {
            case 'profile':
                return <ProfilePage commonObj={this.props.commonObj}></ProfilePage>
            case 'changePass':
                return <ChangePassPage commonObj={this.props.commonObj}></ChangePassPage>
            case 'photo':
                return <PhotoPage commonObj={this.props.commonObj}></PhotoPage>
            default:
                return null;
        }
    }

    render() {
        this.props.commonObj.showPopup = this.showPopup.bind(this);
        this.props.commonObj.setPage = this.setPage.bind(this);

        return (
            <div>
                <HeaderView commonObj={this.props.commonObj}></HeaderView>
                { this.getPage() }
                {this.state.popups.map((text, id) => <Popup key={"popup"+id} onOkClick={this.closePopup.bind(this)}>{text}</Popup>)}
            </div>
        );
    }
}

export default HomePage;