import React from "react";
import Helper from "../helper";

class LoginView extends React.Component {
    constructor() {
        super();
        this.state = {
            error: ""
        }
    }

    render() {
        return (
            <>
                <span className="error">{ this.state.error }</span>
                <form onSubmit={this.submitForm.bind(this)}>
                    <label htmlFor="email">e-mail</label>
                    <input type="email" id="email" name="emaill" required/>
                    <label htmlFor="password">password</label>
                    <input type="password" id="password" name="password" required/>
                    <div className="toRight">
                        <span className="link" onClick={this.props.commonObj.toggleRegister}>Register</span>&nbsp;
                        <button type="submit">Login</button>
                    </div>
                </form>
            </>
        );
    }

    setErrorMessage(message) {
        this.setState({ 
            error: message
        });
    }

    async submitForm(e) {
        e.preventDefault();
        let email = e.target.emaill.value;
        let password = e.target.password.value;

        let res = await Helper.fetchAPI("user/login", "POST", { email, password });
        this.setErrorMessage(res.ok ? '' : res.json.message);

        if(!res.ok) return;
        Helper.setCookie("token", res.json.token, 7);
        this.props.commonObj.setLoginState(true);
    }
}

export default LoginView;