import React from "react";
import Helper from "../helper.js";

class PhotosView extends React.Component {

    constructor() {
        super();
        this.state = {
            photos: []
        }
    }

    async fetchPhotos() {
        let res = await Helper.fetchAPI('photos', 'GET');
        if (!res.ok) return;
        res.json.reverse();
            
        this.setState({
            photos: res.json
        });    
    }

    componentDidMount() {
        this.fetchPhotos();
    }

    async onUploadImageClick() {
        const file = await Helper.openImage();
        const formData = new FormData();
        formData.append('file', file);
        await Helper.fetchAPI('photos', 'POST', null, formData);
        this.fetchPhotos();
    }

    onImageClick(photo) {
        this.props.commonObj.selectedPhoto = photo;
        this.props.commonObj.setPage('photo');
    }

    render() {
        this.props.commonObj.fetchPhotos = this.fetchPhotos.bind(this);

        return (
            <div className="horizontalCont">
                <div className="image">
                    <button className="uploadImageBtn" onClick={this.onUploadImageClick.bind(this)}></button>
                </div>
                {this.state.photos.map((photo, index) => 
                    <div className="image" key={"image"+index}>
                        <img src={Helper.filesUrl + photo.file.path} alt={index} onClick={this.onImageClick.bind(this, photo)}></img>
                    </div>
                )}
            </div>
        );
    }

}

export default PhotosView;