import React from "react";
import Helper from "../helper";

class RegisterView extends React.Component {
    constructor() {
        super();
        this.confirmationToken = '';
        this.state = {
            error: "",
            confirmation: ""
        }
    }

    render() {
        return (
            <>
                { this.state.error }
                <form onSubmit={this.submitForm.bind(this)}>
                    <label htmlFor="name">name</label>
                    <input type="text" id="name" name="name" required/>
                    <label htmlFor="lastname">lastname</label>
                    <input type="text" id="lastname" name="lastname" required/>
                    <label htmlFor="email">e-mail</label>
                    <input type="email" id="email" name="emaill" required/>
                    <label htmlFor="password">password</label>
                    <input type="password" id="password" name="password" required/>
                    <div className="toRight">
                        <span className="link" onClick={this.props.commonObj.toggleRegister}>Login</span>&nbsp;
                        <button type="submit">Register</button>
                    </div>
                </form>
                <span>{ this.state.confirmation }</span>
            </>
        );
    }

    setErrorMessage(message) {
        this.setState({ 
            error: message ? <span className="error">{message}</span> : <></>
        });
    }

    showConfirmationMessage(status = 0) {
        let messages = [
            <></>,
            <><br />Please confirm your account <span className="link" onClick={this.onConfirmClick.bind(this)}>here</span></>,
            <><br />Your account has been confirmed. You can now log in.</>,
            <><br /><span className="error">An error accoured while confirming your accont. Please <button onClick={this.onConfirmClick.bind(this)}>try again</button></span></>
        ];

        this.setState({
            confirmation: messages[status]
        });
    }

    async onConfirmClick() {
        let res = await Helper.fetchAPI(`user/confirm/${this.confirmationToken}`, "GET");
        this.showConfirmationMessage(res.ok ? 2 : 3);
    }

    async submitForm(e) {
        e.preventDefault();
        let name = e.target.name.value;
        let lastname = e.target.lastname.value;
        let email = e.target.emaill.value;
        let password = e.target.password.value;

        let res = await Helper.fetchAPI("user/register", "POST", { name, lastname, email, password });
        this.setErrorMessage(res.ok ? '' : res.json.message);
        if(!res.ok) return;
        
        this.confirmationToken = res.json.token;
        this.showConfirmationMessage(1);
        
        console.log(res);

    }
}

export default RegisterView;