function parseBody(req, isJSON) {
    return new Promise((resolve, reject) => {
        let body = "";
        req.on("data", function (data) {
            body += data.toString();
        })

        req.on("end", function (data) {
            if (isJSON) {
                let obj;
                try {
                    obj = JSON.parse(body)
                } catch (error) {
                    console.error(error);
                }

                resolve(obj);
            }

            const params = new URLSearchParams(body);
            const obj = Object.fromEntries(params);
            resolve(obj);
        })
    })
}

module.exports = { parseBody }