const dataController = require('./dataController');
const postParser = require('./postParser');

const routes = [
    {
        method: 'GET',
        url: '/api/tags/raw',
        fun: async (req) => {
            let tags = dataController.getTags(true);
            return [200, tags];
        },
    },
    {
        method: 'GET',
        url: '/api/tags',
        fun: async (req) => {
            let tags = dataController.getTags(false);
            return [200, tags];
        },
    },
    {
        method: 'GET',
        url: '/api/tags/',
        paramAfterURL: true,
        fun: async (req, param) => {
            let tag = dataController.getTag(param);
            return tag ? [200, tag] : [404, { message: 'tag not found' }];
        }
    },
    {
        method: 'POST',
        url: '/api/tags',
        loginRequired: true,
        fun: async (req) => {
            let obj = await postParser.parseBody(req, true);
            if (!obj || Object.keys(obj).length == 0)
                return [400, { message: 'unable to parse JSON' }];
            if (!obj.name)
                return [400, { message: 'tag name is required' }];
            let tag = dataController.addTag(obj.name);
            return tag ? [200, { message: 'success' }] : [409, { message: 'tag already exists' }];
        }
    },
]

module.exports = routes;