const http = require('http');
const tracer = require('tracer').colorConsole();
const HttpRouter = require("./app/httpRouter");
require('dotenv').config();
require('./app/usersController');

const router = new HttpRouter();
router.addRoutes(require('./app/photosRoutes'));
router.addRoutes(require('./app/tagsRoutes'));
router.addRoutes(require('./app/usersRoutes'));
router.addRoutes(require('./app/profileRoutes'));

http
    .createServer((req, res) => router.handleReq(req, res))
    .listen(process.env.APP_PORT, () => tracer.log("listen on " + process.env.APP_PORT))